osgText::TextBase Class Referenceabstract

`#include <TextBase>`

Inheritance diagram for osgText::TextBase:

## Public Types

enum | CharacterSizeMode { OBJECT_COORDS , SCREEN_COORDS , OBJECT_COORDS_WITH_MAXIMUM_SCREEN_SIZE_CAPPED_BY_FONT_HEIGHT }
enum | AlignmentType { LEFT_TOP , LEFT_CENTER , LEFT_BOTTOM , CENTER_TOP , CENTER_CENTER , CENTER_BOTTOM , RIGHT_TOP , RIGHT_CENTER , RIGHT_BOTTOM , LEFT_BASE_LINE , CENTER_BASE_LINE , RIGHT_BASE_LINE , LEFT_BOTTOM_BASE_LINE , CENTER_BOTTOM_BASE_LINE , RIGHT_BOTTOM_BASE_LINE , BASE_LINE = LEFT_BASE_LINE }
enum | AxisAlignment { XY_PLANE , REVERSED_XY_PLANE , XZ_PLANE , REVERSED_XZ_PLANE , YZ_PLANE , REVERSED_YZ_PLANE , SCREEN , USER_DEFINED_ROTATION }
enum | Layout { LEFT_TO_RIGHT , RIGHT_TO_LEFT , VERTICAL }
enum | DrawModeMask { TEXT = 1 , BOUNDINGBOX = 2 , FILLEDBOUNDINGBOX = 4 , ALIGNMENT = 8 }
typedef osg::ref_ptr< osg::Vec3Array > | Coords
Public Types inherited from osg::Drawable

enum

AttributeTypes {
VERTICES = 0 , WEIGHTS = 1 , NORMALS = 2 , COLORS = 3 ,
SECONDARY_COLORS = 4 , FOG_COORDS = 5 , ATTRIBUTE_6 = 6 , ATTRIBUTE_7 = 7 ,
TEXTURE_COORDS = 8 , TEXTURE_COORDS_0 = TEXTURE_COORDS , TEXTURE_COORDS_1 = TEXTURE_COORDS_0+1 , TEXTURE_COORDS_2 = TEXTURE_COORDS_0+2 ,
TEXTURE_COORDS_3 = TEXTURE_COORDS_0+3 , TEXTURE_COORDS_4 = TEXTURE_COORDS_0+4 , TEXTURE_COORDS_5 = TEXTURE_COORDS_0+5 , TEXTURE_COORDS_6 = TEXTURE_COORDS_0+6 ,
TEXTURE_COORDS_7 = TEXTURE_COORDS_0+7
}

typedef DrawableUpdateCallback | UpdateCallback
typedef DrawableEventCallback | EventCallback
typedef DrawableCullCallback | CullCallback
typedef unsigned int | AttributeType
Public Types inherited from osg::Node
typedef std::vector< Group * > | ParentList
typedef unsigned int | NodeMask
typedef std::vector< std::string > | DescriptionList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| TextBase ()
| TextBase (const TextBase &text, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
virtual bool | isSameKindAs (const osg::Object *obj) const
virtual const char * | className () const
virtual const char * | libraryName () const
void | setColor (const osg::Vec4 &color)
const osg::Vec4 & | getColor () const
virtual void | setFont (Font *font=0)
virtual void | setFont (osg::ref_ptr< Font > font)
virtual void | setFont (const std::string &fontfile)
Font * | getFont ()
const Font * | getFont () const
void | setStyle (Style *style)
Style * | getStyle ()
const Style * | getStyle () const
Style * | getOrCreateStyle ()
void | setFontResolution (unsigned int width, unsigned int height)
unsigned int | getFontWidth () const
unsigned int | getFontHeight () const
void | setText (const String &text)
void | setText (const std::string &text)
void | setText (const std::string &text, String::Encoding encoding)
void | setText (const wchar_t *text)
String & | getText ()
const String & | getText () const
void | update ()
void | setCharacterSize (float height)
void | setCharacterSize (float height, float aspectRatio)
float | getCharacterHeight () const
float | getCharacterAspectRatio () const
void | setCharacterSizeMode (CharacterSizeMode mode)
CharacterSizeMode | getCharacterSizeMode () const
void | setMaximumWidth (float maximumWidth)
float | getMaximumWidth () const
void | setMaximumHeight (float maximumHeight)
float | getMaximumHeight () const
void | setLineSpacing (float lineSpacing)
float | getLineSpacing () const
void | setPosition (const osg::Vec3 &pos)
const osg::Vec3 & | getPosition () const
void | setAlignment (AlignmentType alignment)
AlignmentType | getAlignment () const
void | setAxisAlignment (AxisAlignment axis)
AxisAlignment | getAxisAlignment () const
void | setRotation (const osg::Quat &quat)
const osg::Quat & | getRotation () const
void | setAutoRotateToScreen (bool autoRotateToScreen)
bool | getAutoRotateToScreen () const
void | setLayout (Layout layout)
Layout | getLayout () const
void | setDrawMode (unsigned int mode)
unsigned int | getDrawMode () const
void | setBoundingBoxMargin (float margin)
float | getBoundingBoxMargin () const
void | setBoundingBoxColor (const osg::Vec4 &color)
const osg::Vec4 & | getBoundingBoxColor () const
void | setKerningType (KerningType kerningType)
KerningType | getKerningType () const
unsigned int | getLineCount () const
virtual void | compileGLObjects (osg::RenderInfo &renderInfo) const
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (osg::State *state=0) const
virtual osg::BoundingBox | computeBoundingBox () const
Coords & | getCoords ()
const Coords & | getCoords () const
void | getCoord (unsigned int i, osg::Vec2 &c) const
void | getCoord (unsigned int i, osg::Vec3 &c) const
const osg::Matrix & | getMatrix () const
bool | computeMatrix (osg::Matrix &matrix, osg::State *state=0) const
Public Member Functions inherited from osg::Drawable
| Drawable ()
| Drawable (const Drawable &drawable, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, Drawable)
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual void | computeDataVariance ()
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setInitialBound (const osg::BoundingBox &bbox)
const BoundingBox & | getInitialBound () const
const BoundingSphere & | getBound () const
const BoundingBox & | getBoundingBox () const
virtual BoundingSphere | computeBound () const
void | setComputeBoundingBoxCallback (ComputeBoundingBoxCallback *callback)
ComputeBoundingBoxCallback * | getComputeBoundingBoxCallback ()
const ComputeBoundingBoxCallback * | getComputeBoundingBoxCallback () const
virtual void | setShape (Shape *shape)
template<class T>
void | setShape (const ref_ptr< T > &shape)
Shape * | getShape ()
const Shape * | getShape () const
void | setSupportsDisplayList (bool flag)
bool | getSupportsDisplayList () const
void | setUseDisplayList (bool flag)
bool | getUseDisplayList () const
GLuint & | getDisplayList (unsigned int contextID) const
virtual void | setUseVertexBufferObjects (bool flag)
bool | getUseVertexBufferObjects () const
void | setUseVertexArrayObject (bool flag)
bool | getUseVertexArrayObject () const
virtual void | dirtyGLObjects ()
virtual unsigned int | getGLObjectSizeHint () const
void | draw (RenderInfo &renderInfo) const
void | drawInner (RenderInfo &renderInfo) const
void | setCreateVertexArrayStateCallback (CreateVertexArrayStateCallback *cb)
CreateVertexArrayStateCallback * | getCreateVertexArrayStateCallback ()
const CreateVertexArrayStateCallback * | getCreateVertexArrayStateCallback () const
VertexArrayState * | createVertexArrayState (RenderInfo &renderInfo) const
void | setVertexArrayStateList (VertexArrayStateList &vasl)
VertexArrayStateList & | getVertexArrayStateList ()
const VertexArrayStateList & | getVertexArrayStateList () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setDrawCallback (DrawCallback *dc)
DrawCallback * | getDrawCallback ()
const DrawCallback * | getDrawCallback () const
virtual void | drawImplementation (RenderInfo &) const
virtual bool | supports (const AttributeFunctor &) const
virtual void | accept (AttributeFunctor &)
virtual bool | supports (const ConstAttributeFunctor &) const
virtual void | accept (ConstAttributeFunctor &) const
virtual bool | supports (const PrimitiveFunctor &) const
virtual void | accept (PrimitiveFunctor &) const
virtual bool | supports (const PrimitiveIndexFunctor &) const
virtual void | accept (PrimitiveIndexFunctor &) const
Public Member Functions inherited from osg::Node
| Node ()
| Node (const Node &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const
virtual Object * | clone (const CopyOp &copyop) const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual Geometry * | asGeometry ()
virtual const Geometry * | asGeometry () const
virtual Group * | asGroup ()
virtual const Group * | asGroup () const
virtual Transform * | asTransform ()
virtual const Transform * | asTransform () const
virtual Switch * | asSwitch ()
virtual const Switch * | asSwitch () const
virtual Geode * | asGeode ()
virtual const Geode * | asGeode () const
virtual osgTerrain::Terrain * | asTerrain ()
virtual const osgTerrain::Terrain * | asTerrain () const
virtual void | accept (NodeVisitor &nv)
virtual void | ascend (NodeVisitor &nv)
virtual void | traverse (NodeVisitor &)
const ParentList & | getParents () const
ParentList | getParents ()
Group * | getParent (unsigned int i)
const Group * | getParent (unsigned int i) const
unsigned int | getNumParents () const
NodePathList | getParentalNodePaths (osg::Node *haltTraversalAtNode=0) const
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setUpdateCallback (Callback *nc)
template<class T>
void | setUpdateCallback (const ref_ptr< T > &nc)
Callback * | getUpdateCallback ()
const Callback * | getUpdateCallback () const
void | addUpdateCallback (Callback *nc)
template<class T>
void | addUpdateCallback (const ref_ptr< T > &nc)
void | removeUpdateCallback (Callback *nc)
template<class T>
void | removeUpdateCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringUpdateTraversal () const
void | setEventCallback (Callback *nc)
template<class T>
void | setEventCallback (const ref_ptr< T > &nc)
Callback * | getEventCallback ()
const Callback * | getEventCallback () const
void | addEventCallback (Callback *nc)
template<class T>
void | addEventCallback (const ref_ptr< T > &nc)
void | removeEventCallback (Callback *nc)
template<class T>
void | removeEventCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringEventTraversal () const
void | setCullCallback (Callback *nc)
template<class T>
void | setCullCallback (const ref_ptr< T > &nc)
Callback * | getCullCallback ()
const Callback * | getCullCallback () const
void | addCullCallback (Callback *nc)
template<class T>
void | addCullCallback (const ref_ptr< T > &nc)
void | removeCullCallback (Callback *nc)
template<class T>
void | removeCullCallback (const ref_ptr< T > &nc)
void | setCullingActive (bool active)
bool | getCullingActive () const
unsigned int | getNumChildrenWithCullingDisabled () const
bool | isCullingActive () const
unsigned int | getNumChildrenWithOccluderNodes () const
bool | containsOccluderNodes () const
void | setNodeMask (NodeMask nm)
NodeMask | getNodeMask () const
void | setStateSet (osg::StateSet *stateset)
template<class T>
void | setStateSet (const osg::ref_ptr< T > &stateset)
osg::StateSet * | getOrCreateStateSet ()
osg::StateSet * | getStateSet ()
const osg::StateSet * | getStateSet () const
void | setDescriptions (const DescriptionList &descriptions)
DescriptionList & | getDescriptions ()
const DescriptionList & | getDescriptions () const
const std::string & | getDescription (unsigned int i) const
std::string & | getDescription (unsigned int i)
unsigned int | getNumDescriptions () const
void | addDescription (const std::string &desc)
void | setInitialBound (const osg::BoundingSphere &bsphere)
const BoundingSphere & | getInitialBound () const
void | dirtyBound ()
const BoundingSphere & | getBound () const
void | setComputeBoundingSphereCallback (ComputeBoundingSphereCallback *callback)
template<class T>
void | setComputeBoundingSphereCallback (const ref_ptr< T > &callback)
ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback ()
const ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Types

typedef osg::ref_ptr< osg::Vec2Array > | TexCoords
typedef osg::ref_ptr< osg::Vec4Array > | ColorCoords
typedef std::vector< osg::ref_ptr< osg::DrawElements > > | Primitives
Protected Types inherited from osg::Drawable
typedef osg::buffered_value< GLuint > | GLObjectList

## Protected Member Functions

virtual | ~TextBase ()
virtual osg::StateSet * | createStateSet ()
virtual void | assignStateSet ()
void | initArraysAndBuffers ()
osg::VertexArrayState * | createVertexArrayStateImplementation (osg::RenderInfo &renderInfo) const
void | positionCursor (const osg::Vec2 &endOfLine_coords, osg::Vec2 &cursor, unsigned int linelength)
String::iterator | computeLastCharacterOnLine (osg::Vec2 &cursor, String::iterator first, String::iterator last)
void | computePositions ()
virtual void | computePositionsImplementation ()
virtual void | computeGlyphRepresentation ()=0
void | setupDecoration ()
unsigned int | addCoord (const osg::Vec2 &c)
unsigned int | addCoord (const osg::Vec3 &c)
void | addTexCoord (const osg::Vec2 &tc)
Protected Member Functions inherited from osg::Drawable
Drawable & | operator= (const Drawable &)
virtual | ~Drawable ()
void | setBound (const BoundingBox &bb) const
Protected Member Functions inherited from osg::Node
virtual | ~Node ()
void | addParent (osg::Group *parent)
void | removeParent (osg::Group *parent)
void | setNumChildrenRequiringUpdateTraversal (unsigned int num)
void | setNumChildrenRequiringEventTraversal (unsigned int num)
void | setNumChildrenWithCullingDisabled (unsigned int num)
void | setNumChildrenWithOccluderNodes (unsigned int num)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

osg::Vec4 | _color
osg::ref_ptr< Font > | _font
osg::ref_ptr< Font > | _fontFallback
osg::ref_ptr< Style > | _style
FontResolution | _fontSize
float | _characterHeight
CharacterSizeMode | _characterSizeMode
float | _maximumWidth
float | _maximumHeight
float | _lineSpacing
String | _text
osg::Vec3 | _position
AlignmentType | _alignment
AxisAlignment | _axisAlignment
osg::Quat | _rotation
bool | _autoRotateToScreen
Layout | _layout
unsigned int | _drawMode
float | _textBBMargin
osg::Vec4 | _textBBColor
KerningType | _kerningType
unsigned int | _lineCount
bool | _glyphNormalized
osg::Vec3 | _offset
osg::Vec3 | _normal
osg::BoundingBox | _textBB
osg::BoundingBox | _textBBWithMargin
osg::Matrix | _matrix
Primitives | _decorationPrimitives
osg::ref_ptr< osg::VertexBufferObject > | _vbo
osg::ref_ptr< osg::ElementBufferObject > | _ebo
Coords | _coords
Coords | _normals
ColorCoords | _colorCoords
TexCoords | _texcoords
Protected Attributes inherited from osg::Drawable
BoundingBox | _initialBoundingBox
ref_ptr< ComputeBoundingBoxCallback > | _computeBoundingBoxCallback
BoundingBox | _boundingBox
ref_ptr< Shape > | _shape
bool | _supportsDisplayList
bool | _useDisplayList
bool | _supportsVertexBufferObjects
bool | _useVertexBufferObjects
bool | _useVertexArrayObject
GLObjectList | _globjList
VertexArrayStateList | _vertexArrayStateList
ref_ptr< DrawCallback > | _drawCallback
ref_ptr< CreateVertexArrayStateCallback > | _createVertexArrayStateCallback
Protected Attributes inherited from osg::Node
BoundingSphere | _initialBound
ref_ptr< ComputeBoundingSphereCallback > | _computeBoundCallback
BoundingSphere | _boundingSphere
bool | _boundingSphereComputed
ParentList | _parents
ref_ptr< Callback > | _updateCallback
unsigned int | _numChildrenRequiringUpdateTraversal
ref_ptr< Callback > | _eventCallback
unsigned int | _numChildrenRequiringEventTraversal
ref_ptr< Callback > | _cullCallback
bool | _cullingActive
unsigned int | _numChildrenWithCullingDisabled
unsigned int | _numChildrenWithOccluderNodes
NodeMask | _nodeMask
ref_ptr< StateSet > | _stateset
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Drawable
static GLuint | generateDisplayList (unsigned int contextID, unsigned int sizeHint=0)
static void | deleteDisplayList (unsigned int contextID, GLuint globj, unsigned int sizeHint=0)
static void | setMinimumNumberOfDisplayListsToRetainInCache (unsigned int minimum)
static unsigned int | getMinimumNumberOfDisplayListsToRetainInCache ()
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Member Typedef Documentation

## ColorCoords

typedef osg::ref_ptr<osg::Vec4Array> osgText::TextBase::ColorCoords

protected

## Coords

typedef osg::ref_ptr<osg::Vec3Array> osgText::TextBase::Coords

## Primitives

typedef std::vector< osg::ref_ptr<osg::DrawElements> > osgText::TextBase::Primitives

protected

## TexCoords

typedef osg::ref_ptr<osg::Vec2Array> osgText::TextBase::TexCoords

protected

## Member Enumeration Documentation

## AlignmentType

enum osgText::TextBase::AlignmentType

Enumerator
LEFT_TOP |
LEFT_CENTER |
LEFT_BOTTOM |
CENTER_TOP |
CENTER_CENTER |
CENTER_BOTTOM |
RIGHT_TOP |
RIGHT_CENTER |
RIGHT_BOTTOM |
LEFT_BASE_LINE |
CENTER_BASE_LINE |
RIGHT_BASE_LINE |
LEFT_BOTTOM_BASE_LINE |
CENTER_BOTTOM_BASE_LINE |
RIGHT_BOTTOM_BASE_LINE |
BASE_LINE |

## AxisAlignment

enum osgText::TextBase::AxisAlignment

Enumerator
XY_PLANE |
REVERSED_XY_PLANE |
XZ_PLANE |
REVERSED_XZ_PLANE |
YZ_PLANE |
REVERSED_YZ_PLANE |
SCREEN |
USER_DEFINED_ROTATION |

## CharacterSizeMode

enum osgText::TextBase::CharacterSizeMode

Enumerator
OBJECT_COORDS |
SCREEN_COORDS | default
OBJECT_COORDS_WITH_MAXIMUM_SCREEN_SIZE_CAPPED_BY_FONT_HEIGHT | internally scale the characters to be constant screen size. text that behavaves like OBJECT_COORDS sized text when a long distance way, but has its screen sized capped automatically when the viewer gets near.

## DrawModeMask

enum osgText::TextBase::DrawModeMask

Enumerator
TEXT |
BOUNDINGBOX | default
FILLEDBOUNDINGBOX |
ALIGNMENT |

## Layout

enum osgText::TextBase::Layout

Enumerator
LEFT_TO_RIGHT |
RIGHT_TO_LEFT | default
VERTICAL |

## Constructor & Destructor Documentation

## TextBase() [1/2]

osgText::TextBase::TextBase | ( |  | ) |

Referenced by isSameKindAs(), and TextBase().

## TextBase() [2/2]

osgText::TextBase::TextBase | ( | const TextBase & | text,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

References osg::CopyOp::SHALLOW_COPY, and TextBase().

## ~TextBase()

virtual osgText::TextBase::~TextBase | ( |  | ) |

protected virtual

## Member Function Documentation

## addCoord() [1/2]

unsigned int osgText::TextBase::addCoord | ( | const osg::Vec2 & | c | ) |

inline protected

References _coords, osg::Vec2f::x(), and osg::Vec2f::y().

## addCoord() [2/2]

unsigned int osgText::TextBase::addCoord | ( | const osg::Vec3 & | c | ) |

inline protected

References _coords.

## addTexCoord()

void osgText::TextBase::addTexCoord | ( | const osg::Vec2 & | tc | ) |

inline protected

References _texcoords.

## assignStateSet()

virtual void osgText::TextBase::assignStateSet | ( |  | ) |

protected virtual

## className()

virtual const char * osgText::TextBase::className | ( |  | ) | const

inline virtual

return the name of the node's class type.

Reimplemented from osg::Node.

Reimplemented in osgText::Text.

## compileGLObjects()

virtual void osgText::TextBase::compileGLObjects | ( | osg::RenderInfo & | renderInfo | ) | const

virtual

Immediately compile this `Drawable` into an OpenGL Display List/VertexBufferObjects.

Note
  Operation is ignored if `_useDisplayList` is `false` or VertexBufferObjects are not used.

Reimplemented from osg::Drawable.

## computeBoundingBox()

virtual osg::BoundingBox osgText::TextBase::computeBoundingBox | ( |  | ) | const

virtual

Compute the bounding box around Drawables's geometry.

Reimplemented from osg::Drawable.

Reimplemented in osgText::Text3D.

## computeGlyphRepresentation()

virtual void osgText::TextBase::computeGlyphRepresentation | ( |  | ) |

protected pure virtual

Implemented in osgText::Text3D, and osgText::Text.

Referenced by update().

## computeLastCharacterOnLine()

String::iterator osgText::TextBase::computeLastCharacterOnLine | ( | osg::Vec2 & | cursor,
|  | String::iterator | first,
|  | String::iterator | last )

protected

## computeMatrix()

bool osgText::TextBase::computeMatrix | ( | osg::Matrix & | matrix,
|  | osg::State * | state = 0 ) const

compute the matrix that positions the text in model space for the given viewpoint.

## computePositions()

void osgText::TextBase::computePositions | ( |  | ) |

protected

## computePositionsImplementation()

virtual void osgText::TextBase::computePositionsImplementation | ( |  | ) |

protected virtual

Reimplemented in osgText::Text.

## createStateSet()

virtual osg::StateSet * osgText::TextBase::createStateSet | ( |  | ) |

protected virtual

Reimplemented in osgText::Text.

## createVertexArrayStateImplementation()

osg::VertexArrayState * osgText::TextBase::createVertexArrayStateImplementation | ( | osg::RenderInfo & | renderInfo | ) | const

protected virtual

Implementation of Create the VertexArrayState object.

Reimplemented from osg::Drawable.

## getAlignment()

AlignmentType osgText::TextBase::getAlignment | ( |  | ) | const

inline

References _alignment.

## getAutoRotateToScreen()

bool osgText::TextBase::getAutoRotateToScreen | ( |  | ) | const

inline

References _autoRotateToScreen.

## getAxisAlignment()

AxisAlignment osgText::TextBase::getAxisAlignment | ( |  | ) | const

inline

References _axisAlignment.

## getBoundingBoxColor()

const osg::Vec4 & osgText::TextBase::getBoundingBoxColor | ( |  | ) | const

inline

References _textBBColor.

## getBoundingBoxMargin()

float osgText::TextBase::getBoundingBoxMargin | ( |  | ) | const

inline

References _textBBMargin.

## getCharacterAspectRatio()

float osgText::TextBase::getCharacterAspectRatio | ( |  | ) | const

inline

References _style.

## getCharacterHeight()

float osgText::TextBase::getCharacterHeight | ( |  | ) | const

inline

References _characterHeight.

## getCharacterSizeMode()

CharacterSizeMode osgText::TextBase::getCharacterSizeMode | ( |  | ) | const

inline

Get the CharacterSizeMode.

References _characterSizeMode.

## getColor()

const osg::Vec4 & osgText::TextBase::getColor | ( |  | ) | const

inline

References _color.

## getCoord() [1/2]

void osgText::TextBase::getCoord | ( | unsigned int | i,
|  | osg::Vec2 & | c ) const

inline

References _coords, and osg::Vec2f::set().

## getCoord() [2/2]

void osgText::TextBase::getCoord | ( | unsigned int | i,
|  | osg::Vec3 & | c ) const

inline

## getCoords() [1/2]

Coords & osgText::TextBase::getCoords | ( |  | ) |

inline

References _coords.

## getCoords() [2/2]

const Coords & osgText::TextBase::getCoords | ( |  | ) | const

inline

References _coords.

## getDrawMode()

unsigned int osgText::TextBase::getDrawMode | ( |  | ) | const

inline

References _drawMode.

## getFont() [1/2]

Font * osgText::TextBase::getFont | ( |  | ) |

inline

Get the font. Return 0 if default is being used.

References _font.

## getFont() [2/2]

const Font * osgText::TextBase::getFont | ( |  | ) | const

inline

Get the const font. Return 0 if default is being used.

References _font.

## getFontHeight()

unsigned int osgText::TextBase::getFontHeight | ( |  | ) | const

inline

References _fontSize.

## getFontWidth()

unsigned int osgText::TextBase::getFontWidth | ( |  | ) | const

inline

References _fontSize.

## getKerningType()

KerningType osgText::TextBase::getKerningType | ( |  | ) | const

inline

References _kerningType.

## getLayout()

Layout osgText::TextBase::getLayout | ( |  | ) | const

inline

References _layout.

## getLineCount()

unsigned int osgText::TextBase::getLineCount | ( |  | ) | const

inline

Get the number of wrapped lines - only valid after computeGlyphRepresentation() has been called, returns 0 otherwise

References _lineCount.

## getLineSpacing()

float osgText::TextBase::getLineSpacing | ( |  | ) | const

inline

Get the line spacing of the text box.

References _lineSpacing.

## getMatrix()

const osg::Matrix & osgText::TextBase::getMatrix | ( |  | ) | const

inline

Get the cached internal matrix used to provide positioning of text. The cached matrix is originally computed by computeMatrix(..).

References _matrix.

## getMaximumHeight()

float osgText::TextBase::getMaximumHeight | ( |  | ) | const

inline

Get the maximum height of the text box.

References _maximumHeight.

## getMaximumWidth()

float osgText::TextBase::getMaximumWidth | ( |  | ) | const

inline

Get the maximim width of the text box.

References _maximumWidth.

## getOrCreateStyle()

Style * osgText::TextBase::getOrCreateStyle | ( |  | ) |

inline

Get or create the text style.

References _style.

## getPosition()

const osg::Vec3 & osgText::TextBase::getPosition | ( |  | ) | const

inline

Get the position of text.

References _position.

## getRotation()

const osg::Quat & osgText::TextBase::getRotation | ( |  | ) | const

inline

References _rotation.

## getStyle() [1/2]

Style * osgText::TextBase::getStyle | ( |  | ) |

inline

Get the text style.

References _style.

## getStyle() [2/2]

const Style * osgText::TextBase::getStyle | ( |  | ) | const

inline

Get the const text style.

References _style.

## getText() [1/2]

String & osgText::TextBase::getText | ( |  | ) |

inline

Get the text string. Note, if you modify the string you must call Text::update() for the internal glyph reprentation to be updated.

References _text.

## getText() [2/2]

const String & osgText::TextBase::getText | ( |  | ) | const

inline

Get the const text string.

References _text.

## initArraysAndBuffers()

void osgText::TextBase::initArraysAndBuffers | ( |  | ) |

protected

## isSameKindAs()

virtual bool osgText::TextBase::isSameKindAs | ( | const osg::Object * | obj | ) | const

inline virtual

return true if this and obj are of the same kind of object.

Reimplemented from osg::Node.

Reimplemented in osgText::Text.

References NULL, and TextBase().

## libraryName()

virtual const char * osgText::TextBase::libraryName | ( |  | ) | const

inline virtual

return the name of the node's library.

Reimplemented from osg::Node.

Reimplemented in osgText::Text.

## positionCursor()

void osgText::TextBase::positionCursor | ( | const osg::Vec2 & | endOfLine_coords,
|  | osg::Vec2 & | cursor,
|  | unsigned int | linelength )

protected

## releaseGLObjects()

virtual void osgText::TextBase::releaseGLObjects | ( | osg::State * | state = 0 | ) | const

virtual

If State is non-zero, this function releases OpenGL objects for the specified graphics context. Otherwise, releases OpenGL objexts for all graphics contexts.

Reimplemented from osg::Drawable.

Reimplemented in osgText::Text3D, and osgText::Text.

## resizeGLObjectBuffers()

virtual void osgText::TextBase::resizeGLObjectBuffers | ( | unsigned int | maxSize | ) |

virtual

Resize any per context GLObject buffers to specified size.

Reimplemented from osg::Drawable.

Reimplemented in osgText::Text3D, and osgText::Text.

## setAlignment()

void osgText::TextBase::setAlignment | ( | AlignmentType | alignment | ) |

## setAutoRotateToScreen()

void osgText::TextBase::setAutoRotateToScreen | ( | bool | autoRotateToScreen | ) |

## setAxisAlignment()

void osgText::TextBase::setAxisAlignment | ( | AxisAlignment | axis | ) |

## setBoundingBoxColor()

void osgText::TextBase::setBoundingBoxColor | ( | const osg::Vec4 & | color | ) |

inline

References _textBBColor.

## setBoundingBoxMargin()

void osgText::TextBase::setBoundingBoxMargin | ( | float | margin | ) |

## setCharacterSize() [1/2]

void osgText::TextBase::setCharacterSize | ( | float | height | ) |

Set the rendered character size in object coordinates.

## setCharacterSize() [2/2]

void osgText::TextBase::setCharacterSize | ( | float | height,
|  | float | aspectRatio )

Set the rendered character size in object coordinates.

## setCharacterSizeMode()

void osgText::TextBase::setCharacterSizeMode | ( | CharacterSizeMode | mode | ) |

inline

Set how the CharacterSize value relates to the final rendered character.

References _characterSizeMode.

## setColor()

void osgText::TextBase::setColor | ( | const osg::Vec4 & | color | ) |

## setDrawMode()

void osgText::TextBase::setDrawMode | ( | unsigned int | mode | ) |

## setFont() [1/3]

virtual void osgText::TextBase::setFont | ( | const std::string & | fontfile | ) |

virtual

Set the font, loaded from the specified front file, to use to render the text, setFont("") sets the use of the default font. See the osgText::readFontFile function for how the font file will be located.

## setFont() [2/3]

virtual void osgText::TextBase::setFont | ( | Font * | font = 0 | ) |

inline virtual

Set the Font to use to render the text. setFont(0) sets the use of the default font.

References setFont().

Referenced by setFont().

## setFont() [3/3]

virtual void osgText::TextBase::setFont | ( | osg::ref_ptr< Font > | font | ) |

virtual

Set the Font to use to render the text.

## setFontResolution()

void osgText::TextBase::setFontResolution | ( | unsigned int | width,
|  | unsigned int | height )

Set the Font reference width and height resolution in texels. Note, the size may not be supported by current font, the closest supported font size will be selected.

## setKerningType()

void osgText::TextBase::setKerningType | ( | KerningType | kerningType | ) |

inline

References _kerningType.

## setLayout()

void osgText::TextBase::setLayout | ( | Layout | layout | ) |

## setLineSpacing()

void osgText::TextBase::setLineSpacing | ( | float | lineSpacing | ) |

Set the line spacing of the text box, given as a percentage of the character height. The default value is 0 for backward compatibility. For longer paragraphs of text, a value of at least 25% (i.e. set line spacing to 0.25) is recommended.

## setMaximumHeight()

void osgText::TextBase::setMaximumHeight | ( | float | maximumHeight | ) |

Set the maximum height of the text box. With horizontal layouts any characters which do not fit are wrapped around. 0 or negative values indicate that no maximum height is set, lines can be as long as they need be to fit the required text

## setMaximumWidth()

void osgText::TextBase::setMaximumWidth | ( | float | maximumWidth | ) |

Set the maximum width of the text box. With horizontal layouts any characters which do not fit are wrapped around. 0 or negative values indicate that no maximum width is set, lines can be as long as they need be to fit thre required text

## setPosition()

void osgText::TextBase::setPosition | ( | const osg::Vec3 & | pos | ) |

Set the position of text.

## setRotation()

void osgText::TextBase::setRotation | ( | const osg::Quat & | quat | ) |

## setStyle()

void osgText::TextBase::setStyle | ( | Style * | style | ) |

inline

Set the text style.

References _style.

## setText() [1/4]

void osgText::TextBase::setText | ( | const std::string & | text | ) |

Set the text using a std::string, which is converted to an internal TextString.

## setText() [2/4]

void osgText::TextBase::setText | ( | const std::string & | text,
|  | String::Encoding | encoding )

Set the text using a Unicode encoded std::string, which is converted to an internal TextString. The encoding parameter specificies which Unicode encodeding is used in the std::string.

## setText() [3/4]

void osgText::TextBase::setText | ( | const String & | text | ) |

Set the text using a osgText::String.

## setText() [4/4]

void osgText::TextBase::setText | ( | const wchar_t * | text | ) |

Set the text using a wchar_t string, which is converted to an internal TextString.

## setupDecoration()

void osgText::TextBase::setupDecoration | ( |  | ) |

protected

## update()

void osgText::TextBase::update | ( |  | ) |

inline

update internal glyph respresentation used for rendering, and bounding volume.

References computeGlyphRepresentation().

## Member Data Documentation

## _alignment

AlignmentType osgText::TextBase::_alignment

protected

Referenced by getAlignment().

## _autoRotateToScreen

bool osgText::TextBase::_autoRotateToScreen

protected

Referenced by getAutoRotateToScreen().

## _axisAlignment

AxisAlignment osgText::TextBase::_axisAlignment

protected

Referenced by getAxisAlignment().

## _characterHeight

float osgText::TextBase::_characterHeight

protected

Referenced by getCharacterHeight().

## _characterSizeMode

CharacterSizeMode osgText::TextBase::_characterSizeMode

protected

Referenced by getCharacterSizeMode(), and setCharacterSizeMode().

## _color

osg::Vec4 osgText::TextBase::_color

protected

Referenced by getColor().

## _colorCoords

ColorCoords osgText::TextBase::_colorCoords

protected

## _coords

Coords osgText::TextBase::_coords

protected

Referenced by addCoord(), addCoord(), getCoord(), getCoords(), and getCoords().

## _decorationPrimitives

Primitives osgText::TextBase::_decorationPrimitives

protected

## _drawMode

unsigned int osgText::TextBase::_drawMode

protected

Referenced by getDrawMode().

## _ebo

osg::ref_ptr<osg::ElementBufferObject> osgText::TextBase::_ebo

protected

## _font

osg::ref_ptr<Font> osgText::TextBase::_font

protected

Referenced by getFont(), and getFont().

## _fontFallback

osg::ref_ptr<Font> osgText::TextBase::_fontFallback

protected

## _fontSize

FontResolution osgText::TextBase::_fontSize

protected

Referenced by getFontHeight(), and getFontWidth().

## _glyphNormalized

bool osgText::TextBase::_glyphNormalized

protected

## _kerningType

KerningType osgText::TextBase::_kerningType

protected

Referenced by getKerningType(), and setKerningType().

## _layout

Layout osgText::TextBase::_layout

protected

Referenced by getLayout().

## _lineCount

unsigned int osgText::TextBase::_lineCount

protected

Referenced by getLineCount().

## _lineSpacing

float osgText::TextBase::_lineSpacing

protected

Referenced by getLineSpacing().

## _matrix

osg::Matrix osgText::TextBase::_matrix

mutable protected

Referenced by getMatrix().

## _maximumHeight

float osgText::TextBase::_maximumHeight

protected

Referenced by getMaximumHeight().

## _maximumWidth

float osgText::TextBase::_maximumWidth

protected

Referenced by getMaximumWidth().

## _normal

osg::Vec3 osgText::TextBase::_normal

protected

## _normals

Coords osgText::TextBase::_normals

protected

## _offset

osg::Vec3 osgText::TextBase::_offset

protected

## _position

osg::Vec3 osgText::TextBase::_position

protected

Referenced by getPosition().

## _rotation

osg::Quat osgText::TextBase::_rotation

protected

Referenced by getRotation().

## _style

osg::ref_ptr<Style> osgText::TextBase::_style

protected

Referenced by getCharacterAspectRatio(), getOrCreateStyle(), getStyle(), getStyle(), and setStyle().

## _texcoords

TexCoords osgText::TextBase::_texcoords

protected

Referenced by addTexCoord().

## _text

String osgText::TextBase::_text

protected

Referenced by getText(), and getText().

## _textBB

osg::BoundingBox osgText::TextBase::_textBB

protected

## _textBBColor

osg::Vec4 osgText::TextBase::_textBBColor

protected

Referenced by getBoundingBoxColor(), and setBoundingBoxColor().

## _textBBMargin

float osgText::TextBase::_textBBMargin

protected

Referenced by getBoundingBoxMargin().

## _textBBWithMargin

osg::BoundingBox osgText::TextBase::_textBBWithMargin

protected

## _vbo

osg::ref_ptr<osg::VertexBufferObject> osgText::TextBase::_vbo

protected

The documentation for this class was generated from the following file:

- TextBase